﻿local mastery, haste, crit, spd 	= 0, 0, 0, 0
local me,class,spec					= false, 0, 0
local timer 						= 0
local event_type,source_GUID,dest_GUID,spell
local colors
local dot_damage, targets			= {}, {}
local player_resource_id, primary_resource_treshold, execute_percent
local active_frames					= {}
local in_combat						= false

local m		= AffDotsTarget
local f		= AffDotsFocus
m:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" and not self.isMoving then
		self:StartMoving()
		self.isMoving = true
	end
end)
m:SetScript("OnMouseUp", function(self, button)
	local p,_,rp, x, y = self:GetPoint()
	AffDotsOpt.p = p
	AffDotsOpt.rp = rp
	AffDotsOpt.x = x
	AffDotsOpt.y = y
	if button == "LeftButton" and self.isMoving then
		self:StopMovingOrSizing()
		self:SetUserPlaced(false)
		self.isMoving = false
	end
end)
f:SetScript("OnMouseDown", function(self, button)
	if button == "LeftButton" and not self.isMoving then
		self:StartMoving()
		self.isMoving = true
	end
end)
f:SetScript("OnMouseUp", function(self, button)
	local p,_,rp, x, y = self:GetPoint()
	AffDotsOpt.focus_p = p
	AffDotsOpt.focus_rp = rp
	AffDotsOpt.focus_x = x
	AffDotsOpt.focus_y = y
	if button == "LeftButton" and self.isMoving then
		self:StopMovingOrSizing()
		self:SetUserPlaced(false)
		self.isMoving = false
	end
end)

local function Round(num) return math.floor(num+.5) end

local function CombatLog(event_type,spell,dest_GUID)
	if class=="WARLOCK" then
		if spec==1 then
			if(event_type == "SPELL_DAMAGE" and spell == 77799) then
				targets[tostring(dest_GUID).."172"] = {dot_damage["172"],GetTime()}
				targets[tostring(dest_GUID).."30108"] = {dot_damage["30108"],GetTime()}
			elseif(event_type == "SPELL_AURA_APPLIED" or event_type == "SPELL_AURA_REFRESH") then
				if(spell == 172 or spell == 87389) then
					targets[tostring(dest_GUID).."172"] = {dot_damage["172"],GetTime()}
				elseif(spell == 980) then
					targets[tostring(dest_GUID).."980"] = {dot_damage["980"],GetTime()}
				elseif(spell == 30108) then
					targets[tostring(dest_GUID).."30108"] = {dot_damage["30108"],GetTime()}
				end
			end
		elseif spec==2 then
			if(event_type == "SPELL_DAMAGE" and spell == 112089) then
				targets[tostring(dest_GUID).."172"] = {dot_damage["172"],GetTime()}
			elseif(event_type == "SPELL_AURA_APPLIED" or event_type == "SPELL_AURA_REFRESH") then
				if(spell == 172) then
					targets[tostring(dest_GUID).."172"] = {dot_damage["172"],GetTime()}
				elseif(spell == 603) then
					targets[tostring(dest_GUID).."603"] = {dot_damage["603"],GetTime()}
				end
			end
		elseif spec==3 then
			
		end
	end
end

local function GetDotDmg()
	local mas = GetMastery()
	local has = GetRangedHaste()
	local cri = GetSpellCritChance(6)
	local dmg = GetSpellBonusDamage(6)
	if( mas ~= mastery or has ~= haste or cri ~= crit or dmg ~= spd) then
		mastery = mas;
		haste 	= has;
		crit 	= cri;
		spd 	= dmg;
	else
		return
	end
	
	local damage_bonus, tick_every, ticks, duration, damage, dps, meta_bonus

	if class == "WARLOCK" then
		if spec==1 then --Affliction
			damage_bonus 		= (1+crit/100)*(1+(mastery*3.1)/100)
			tick_every 			= 2/(1+(haste/100))

			ticks 				= Round(24/tick_every)
			duration 			= ticks * tick_every
			damage				= ticks*(280+spd*0.26)*damage_bonus
			dps					= Round(damage/duration)
			dot_damage["980"]	= Round(dps/100)/10

			ticks 				= Round(18/tick_every)
			duration 			= ticks * tick_every
			damage		 		= (1926+ticks*spd*0.2)*damage_bonus
			dps					= Round(damage/duration)
			dot_damage["172"]	= Round(dps/100)/10

			ticks 				= Round(14/tick_every)
			duration 			= ticks * tick_every
			damage 				= (1792+ticks*spd*0.24)*damage_bonus
			dps		 			= Round(damage/duration)
			dot_damage["30108"]	= Round(dps/100)/10

		elseif spec==2 then --Demonology
			damage_bonus 		= (1+crit/100)*(1+(mastery)/100)
			meta_bonus			= (1+crit/100)*(1+(mastery*3)/100)
			
			tick_every 			= 2/(1+(haste/100))
			ticks 				= Round(18/tick_every)
			duration 			= ticks * tick_every
			damage		 		= (1926+ticks*spd*0.2)*damage_bonus
			dps					= Round(damage/duration)
			dot_damage["172"]	= Round(dps/100)/10
			
			tick_every 			= 15/(1+(haste/100))
			ticks 				= Round(60/tick_every)
			duration 			= ticks * tick_every
			damage		 		= (1068+spd)*meta_bonus*ticks
			dps					= Round(damage/duration)
			dot_damage["603"]	= Round(dps/100)/10
		elseif spec==3 then --Destruction
			
		end
	end
end

local function SetText(f)
	if f.d.t == "dot" then
		local _,_,_,_,_,duration,expires = UnitDebuff(f.d.target, f.d.spell_name,f.d.rank,"player")
		if duration then
			local current 		= dot_damage[f.d.spell]
			if not targets[tostring(UnitGUID(f.d.target))..f.d.spell] then return end
			local on_target 	= targets[tostring(UnitGUID(f.d.target))..f.d.spell][1]
			local duration_left = expires - GetTime()
			f.cd:SetCooldown(expires-duration, duration)
			if(on_target*AffDotsOpt.color_switch >= current and duration_left>f.d.pandemic) then
				f.background:SetTexture(colors[4][1],colors[4][2],colors[4][3],AffDotsOpt.transparency)
			elseif(on_target >= current) then
				f.background:SetTexture(colors[3][1],colors[3][2],colors[3][3],AffDotsOpt.transparency)
			elseif(on_target*AffDotsOpt.color_switch < current and duration_left > f.d.pandemic) then
				f.background:SetTexture(colors[2][1],colors[2][2],colors[2][3],AffDotsOpt.transparency)
			else
				f.background:SetTexture(colors[1][1],colors[1][2],colors[1][3],AffDotsOpt.transparency)
			end
			if AffDotsOpt.text == "absolute" then
				f.text1:SetText(current);f.text2:SetText(on_target)
			else
				f.text3:SetText(Round(current*100/on_target))
			end
		else
			f.cd:Hide();
			if AffDotsOpt.text == "absolute" then
				f.text1:SetText(dot_damage[f.d.spell]);f.text2:SetText(0)
			else
				f.text3:SetText(100)
			end
			f.background:SetTexture(colors[5][1],colors[5][2],colors[5][3],AffDotsOpt.transparency)
		end
	elseif f.d.t == "debuff" then
		local _,_,_,_,_,duration,expires = UnitDebuff("target", f.d.spell_name,"","player")
		if(expires) then
			f.cd:SetCooldown(expires-duration, duration)
			f.cd:Show();
		else
			f.cd:Hide();
		end
		f.background:SetTexture(colors[5][1],colors[5][2],colors[5][3],AffDotsOpt.transparency)

		if f.d.resource then
			f.text3:SetText(UnitPower("player", player_resource_id))
			if(UnitPower("player", player_resource_id) >= primary_resource_treshold) then
				f.background:SetTexture(colors[1][1],colors[1][2],colors[1][3],AffDotsOpt.transparency)
			end
		end
	elseif f.d.t == "hp" then
		f.background_hp:SetTexture(colors[5][1],colors[5][2],colors[5][3],AffDotsOpt.transparency)
		if UnitExists(f.d.target) then
			local hp = Round(UnitHealth(f.d.target)*100/UnitHealthMax(f.d.target))
			f.text_hp:SetText(hp)
			if execute_percent >= hp then
				f.background_hp:SetTexture(colors[1][1],colors[1][2],colors[1][3],AffDotsOpt.transparency)
			end
		end
		
		local _,_,_,_,_,_,expires1 = UnitDebuff(f.d.target, f.d.coe)
		local _,_,_,_,_,_,expires2 = UnitDebuff(f.d.target, f.d.poison)
		local expires = expires1 or expires2
		if expires then
			local time_remaining = expires - GetTime()
			if 		time_remaining>60 	then f.text_coe:SetText(tostring(math.floor(time_remaining/60)+1).."m")
			elseif 	time_remaining>10	then f.text_coe:SetText("0:" ..tostring(math.floor(time_remaining)))
			else 							 f.text_coe:SetText("0:0"..tostring(math.floor(time_remaining)))
			end
			f.background_coe:SetTexture(colors[1][1],colors[1][2],colors[1][3],AffDotsOpt.transparency)
		else
			f.text_coe:SetText("")
			f.background_coe:SetTexture(colors[5][1],colors[5][2],colors[5][3],AffDotsOpt.transparency)
		end
	end
end

local function Unlock(unlock)
	m:SetMovable(unlock)
	m:EnableMouse(unlock)
	f:SetMovable(unlock)
	f:EnableMouse(unlock)
end

local function Visibility()
	if AffDotsOptions:IsShown() then return end
	if(AffDotsOpt.hide and not in_combat) then
		m:Hide()
	else
		m:Show()
	end

	if(UnitGUID("focus") and AffDotsOpt.focus and (in_combat or not AffDotsOpt.hide)) then
		f:Show()
	else
		f:Hide()
	end
end

local function InitFrames()
	GetDotDmg()
	m:ClearAllPoints()
	f:ClearAllPoints()
	if(AffDotsOpt.layout == "horizontal") then
		m:SetSize(160*AffDotsOpt.scale, 70*AffDotsOpt.scale)
		f:SetSize(160*AffDotsOpt.focus_scale, 70*AffDotsOpt.focus_scale)
	else
		m:SetSize(80*AffDotsOpt.scale, 160*AffDotsOpt.scale)
		f:SetSize(80*AffDotsOpt.focus_scale, 160*AffDotsOpt.focus_scale)
	end
	if(AffDotsOpt.x and AffDotsOpt.y and AffDotsOpt.p and AffDotsOpt.rp) then
		m:SetPoint(AffDotsOpt.p, nil, AffDotsOpt.rp, AffDotsOpt.x, AffDotsOpt.y)
	else
		m:SetPoint("CENTER", 0, 0)
	end
	if(AffDotsOpt.focus_x and AffDotsOpt.focus_y and AffDotsOpt.focus_p and AffDotsOpt.focus_rp) then
		f:SetPoint(AffDotsOpt.focus_p, nil, AffDotsOpt.focus_rp, AffDotsOpt.focus_x, AffDotsOpt.focus_y)
	else
		f:SetPoint("CENTER", 0, 100)
	end
	
	m.frame1:Hide();m.frame2:Hide();m.frame3:Hide();m.frame4:Hide();m.frame5:Hide()
	f.frame1:Hide();f.frame2:Hide();f.frame3:Hide();f.frame4:Hide();f.frame5:Hide()
	m.frame1:SetScale(AffDotsOpt.scale);f.frame1:SetScale(AffDotsOpt.focus_scale);
	m.frame2:SetScale(AffDotsOpt.scale);f.frame2:SetScale(AffDotsOpt.focus_scale);
	m.frame3:SetScale(AffDotsOpt.scale);f.frame3:SetScale(AffDotsOpt.focus_scale);
	m.frame4:SetScale(AffDotsOpt.scale);f.frame4:SetScale(AffDotsOpt.focus_scale);
	m.frame5:SetScale(AffDotsOpt.scale);f.frame5:SetScale(AffDotsOpt.focus_scale);

	for k,v in pairs(active_frames) do
		active_frames[k] = nil
	end
	
	if class == "WARLOCK" then
		m.frame5.d = {t="hp",target="target",coe=GetSpellInfo(1490),poison=GetSpellInfo(93068)}
		f.frame5.d = {t="hp",target="focus",coe=GetSpellInfo(1490),poison=GetSpellInfo(93068)}
		if spec == 1 then
			player_resource_id	= 7; primary_resource_treshold = 4; execute_percent = 20;
			m.frame1.d = {t="dot",target="target",spell_id=980,pandemic=12,order=AffDotsOpt.agony_order}
			m.frame2.d = {t="dot",target="target",spell_id=172,pandemic=9,order=AffDotsOpt.corr_order}
			m.frame3.d = {t="dot",target="target",spell_id=30108,pandemic=7,order=AffDotsOpt.ua_order}
			m.frame4.d = {t="debuff",target="target",spell_id=48181,order=AffDotsOpt.haunt_order,resource=true}
			f.frame1.d = {t="dot",target="focus",spell_id=980,pandemic=12,order=AffDotsOpt.agony_order}
			f.frame2.d = {t="dot",target="focus",spell_id=172,pandemic=9,order=AffDotsOpt.corr_order}
			f.frame3.d = {t="dot",target="focus",spell_id=30108,pandemic=7,order=AffDotsOpt.ua_order}
			f.frame4.d = {t="debuff",target="focus",spell_id=48181,order=AffDotsOpt.haunt_order,resource=true}

			active_frames["1"] = m.frame1;active_frames["2"] = m.frame2;
			active_frames["3"] = m.frame3;active_frames["4"] = m.frame4;
			if AffDotsOpt.focus then
				active_frames["6"] = f.frame1;active_frames["7"] = f.frame2;
				active_frames["8"] = f.frame3;active_frames["9"] = f.frame4;
			end
		elseif spec == 2 then
			player_resource_id	= 15; primary_resource_treshold = 800; execute_percent = 20;
			m.frame1.d = {t="dot",target="target",spell_id=172,pandemic=9,order=AffDotsOpt.demo_corr}
			m.frame2.d = {t="dot",target="target",spell_id=603,pandemic=30,order=AffDotsOpt.demo_doom}
			f.frame1.d = {t="dot",target="focus",spell_id=172,pandemic=9,order=AffDotsOpt.demo_corr}
			f.frame2.d = {t="dot",target="focus",spell_id=603,pandemic=30,order=AffDotsOpt.demo_doom}
			
			active_frames["1"] = m.frame1;active_frames["2"] = m.frame2;
			if AffDotsOpt.focus then
				active_frames["6"] = f.frame1;active_frames["7"] = f.frame2;
			end
		elseif spec == 3 then
			player_resource_id	= 14; primary_resource_treshold = 4; execute_percent = 20;
			m.frame1.d = {t="dot",target="target",spell_id=348,pandemic=8,order=AffDotsOpt.destro_immo}
			f.frame1.d = {t="dot",target="focus",spell_id=348,pandemic=8,order=AffDotsOpt.destro_immo}
			active_frames["1"] = m.frame1
			if AffDotsOpt.focus then
				active_frames["6"] = f.frame1
			end
		end
	end

	for k,v in pairs(active_frames) do 
		active_frames[k]:Show()
		local n,r,i = GetSpellInfo(active_frames[k].d.spell_id)
		active_frames[k].d["spell"] = tostring(active_frames[k].d.spell_id)
		active_frames[k].d["rank"] = r
		active_frames[k].d["spell_name"] = n
		active_frames[k].icon:SetTexture(i)
		active_frames[k].text1:SetText("");active_frames[k].text2:SetText("");active_frames[k].text3:SetText("");
		if(AffDotsOpt.layout == "horizontal") then
			active_frames[k]:SetSize(40, 70)
			active_frames[k]:SetPoint("TOPLEFT", active_frames[k].d.order*40, 0)
			active_frames[k].text1:SetPoint("TOPRIGHT", -5, -5-(AffDotsOpt.icon_pos*35))
			active_frames[k].text2:SetPoint("TOPRIGHT", -5, -20-(AffDotsOpt.icon_pos*35))
			active_frames[k].text3:ClearAllPoints()
			active_frames[k].text3:SetPoint("TOP", 0, -13-(AffDotsOpt.icon_pos*32))
			active_frames[k].icon:SetPoint("TOPLEFT", 5, -35+(AffDotsOpt.icon_pos*30))
		else
			active_frames[k]:SetSize(80, 40)
			active_frames[k]:SetPoint("TOPLEFT", 0, active_frames[k].d.order*-40)
			active_frames[k].text1:SetPoint("TOPRIGHT", -7-(AffDotsOpt.icon_pos*40), -8)
			active_frames[k].text2:SetPoint("TOPRIGHT", -7-(AffDotsOpt.icon_pos*40), -23)
			active_frames[k].text3:ClearAllPoints()
			active_frames[k].text3:SetPoint("RIGHT", -8-(AffDotsOpt.icon_pos*30), 0)
			active_frames[k].icon:SetPoint("TOPLEFT", 5+(AffDotsOpt.icon_pos*40), -5)
		end
		active_frames[k].background:SetAllPoints(active_frames[k])
		active_frames[k].cd:SetAllPoints(active_frames[k].icon)
	end
	
	m.frame5:SetPoint("TOPLEFT", 0, 22);m.frame5:SetScale(AffDotsOpt.scale);
	f.frame5:SetPoint("TOPLEFT", 0, 22);f.frame5:SetScale(AffDotsOpt.focus_scale);
	m.frame5.text_coe:SetPoint("TOPLEFT", 50, -5);m.frame5.text_hp:SetPoint("TOPLEFT", 10, -5);
	f.frame5.text_coe:SetPoint("TOPLEFT", 50, -5);f.frame5.text_hp:SetPoint("TOPLEFT", 10, -5);
	if(AffDotsOpt.coe) then
		active_frames["5"] = m.frame5;m.frame5:Show();
		if AffDotsOpt.focus then 
			active_frames["10"] = f.frame5;f.frame5:Show();
		end
	end
end

function AffDotsOpenColorPicker( b, c )
	ColorPickerFrame:Hide()
	button = b
	color_type = c
	ColorPickerFrame:SetColorRGB(colors[color_type][1], colors[color_type][2], colors[color_type][3])
	restore = colors[color_type]

	ColorPickerFrame.func =
		function ()
			local r,g,b = ColorPickerFrame:GetColorRGB()
			AffDotsOpt["color"..tostring(color_type)] = {r,g,b}; colors[color_type] = {r,g,b};
			getglobal(button:GetName() .. "Color"):SetVertexColor(r,g,b)
		end
	ColorPickerFrame.cancelFunc =
		function ()
			AffDotsOpt["color"..tostring(color_type)] = restore; colors[color_type] = restore;
			getglobal(button:GetName() .. "Color"):SetVertexColor(colors[color_type][1], colors[color_type][2], colors[color_type][3])
		end
	ColorPickerFrame:Show()
end

local function OptionsFrameFunctions()
	AffDotsOptHide:SetChecked(AffDotsOpt.hide)
	AffDotsOptHorizontal:SetChecked(AffDotsOpt.layout=="horizontal")
	AffDotsOptTextType:SetChecked(AffDotsOpt.text=="relative")
	AffDotsOptFocus:SetChecked(AffDotsOpt.focus)
	AffDotsOptCoE:SetChecked(AffDotsOpt.coe)
	AffDotsOptTextPosition:SetChecked(AffDotsOpt.icon_pos)
	AffDotsOptScaleSlider:SetValue(AffDotsOpt.scale)
	getglobal(AffDotsOptScaleSlider:GetName() .. 'Text'):SetText(AffDotsOpt.scale)
	AffDotsOptFScaleSlider:SetValue(AffDotsOpt.focus_scale)
	getglobal(AffDotsOptFScaleSlider:GetName() .. 'Text'):SetText(AffDotsOpt.focus_scale)
	AffDotsOptColorSwitch:SetValue((AffDotsOpt.color_switch-1)*100)
	getglobal(AffDotsOptColorSwitch:GetName() .. 'Text'):SetText((AffDotsOpt.color_switch-1)*100)
	AffDotsOptAlpha:SetValue(AffDotsOpt.transparency)
	getglobal(AffDotsOptAlpha:GetName() .. 'Text'):SetText(AffDotsOpt.transparency)
	AffDotsOptOrderAgony:SetValue(AffDotsOpt.agony_order+1)
	getglobal(AffDotsOptOrderAgony:GetName() .. 'Text'):SetText(AffDotsOpt.agony_order+1)
	AffDotsOptOrderCorr:SetValue(AffDotsOpt.corr_order+1)
	getglobal(AffDotsOptOrderCorr:GetName() .. 'Text'):SetText(AffDotsOpt.corr_order+1)
	AffDotsOptOrderUA:SetValue(AffDotsOpt.ua_order+1)
	getglobal(AffDotsOptOrderUA:GetName() .. 'Text'):SetText(AffDotsOpt.ua_order+1)
	AffDotsOptOrderHaunt:SetValue(AffDotsOpt.haunt_order+1)
	getglobal(AffDotsOptOrderHaunt:GetName() .. 'Text'):SetText(AffDotsOpt.haunt_order+1)
	getglobal(AffDotsOptColor1:GetName() .. "Color"):SetVertexColor(colors[1][1], colors[1][2], colors[1][3])
	getglobal(AffDotsOptColor2:GetName() .. "Color"):SetVertexColor(colors[2][1], colors[2][2], colors[2][3])
	getglobal(AffDotsOptColor3:GetName() .. "Color"):SetVertexColor(colors[3][1], colors[3][2], colors[3][3])
	getglobal(AffDotsOptColor4:GetName() .. "Color"):SetVertexColor(colors[4][1], colors[4][2], colors[4][3])
	getglobal(AffDotsOptColor5:GetName() .. "Color"):SetVertexColor(colors[5][1], colors[5][2], colors[5][3])
	AffDotsOptions:EnableMouse(true)
	AffDotsOptions:SetMovable(true)
	AffDotsOptions:RegisterForDrag("LeftButton")
	AffDotsOptions:SetScript("OnDragStart", function(self) self:StartMoving() end)
	AffDotsOptions:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing()
		self:SetUserPlaced(false)
	end)

	AffDotsOptHide:SetScript("OnClick", function(self)
		AffDotsOpt.hide = not AffDotsOpt.hide
	end)

	AffDotsOptHorizontal:SetScript("OnClick", function(self)
		if(AffDotsOpt.layout == "horizontal") then
			AffDotsOpt.layout = "vertical"
		else
			AffDotsOpt.layout = "horizontal"
		end
		InitFrames()
	end)
	
	AffDotsOptTextType:SetScript("OnClick", function(self)
		if(AffDotsOpt.text == "absolute") then
			AffDotsOpt.text = "relative"
		else
			AffDotsOpt.text = "absolute"
		end
		InitFrames()
	end)

	AffDotsOptFocus:SetScript("OnClick", function(self)
		AffDotsOpt.focus = not AffDotsOpt.focus
		InitFrames()
	end)
	
	AffDotsOptCoE:SetScript("OnClick", function(self)
		AffDotsOpt.coe = not AffDotsOpt.coe
		InitFrames()
	end)

	AffDotsOptTextPosition:SetScript("OnClick", function(self)
		if AffDotsOpt.icon_pos == 0 then AffDotsOpt.icon_pos = 1 else AffDotsOpt.icon_pos = 0 end
		InitFrames();
	end)

	AffDotsOptScaleSlider:SetScript("OnValueChanged", function()
		AffDotsOpt.scale = Round(AffDotsOptScaleSlider:GetValue()*10)/10
		getglobal(AffDotsOptScaleSlider:GetName() .. 'Text'):SetText(AffDotsOpt.scale)
		InitFrames()
	end)

	AffDotsOptFScaleSlider:SetScript("OnValueChanged", function()
		AffDotsOpt.focus_scale = Round(AffDotsOptFScaleSlider:GetValue()*10)/10
		getglobal(AffDotsOptFScaleSlider:GetName() .. 'Text'):SetText(AffDotsOpt.focus_scale)
		InitFrames()
	end)
	
	AffDotsOptAlpha:SetScript("OnValueChanged", function()
		AffDotsOpt.transparency = Round(AffDotsOptAlpha:GetValue()*10)/10
		getglobal(AffDotsOptAlpha:GetName() .. 'Text'):SetText(AffDotsOpt.transparency)
		InitFrames()
	end)

	AffDotsOptOrderHaunt:SetScript("OnValueChanged", function()
		AffDotsOpt.haunt_order = Round(AffDotsOptOrderHaunt:GetValue())-1
		getglobal(AffDotsOptOrderHaunt:GetName() .. 'Text'):SetText(Round(AffDotsOptOrderHaunt:GetValue()))
		InitFrames();
	end)

	AffDotsOptOrderAgony:SetScript("OnValueChanged", function()
		AffDotsOpt.agony_order = Round(AffDotsOptOrderAgony:GetValue())-1
		getglobal(AffDotsOptOrderAgony:GetName() .. 'Text'):SetText(Round(AffDotsOptOrderAgony:GetValue()))
		InitFrames();
	end)

	AffDotsOptOrderCorr:SetScript("OnValueChanged", function()
		AffDotsOpt.corr_order = Round(AffDotsOptOrderCorr:GetValue())-1
		getglobal(AffDotsOptOrderCorr:GetName() .. 'Text'):SetText(Round(AffDotsOptOrderCorr:GetValue()))
		InitFrames();
	end)

	AffDotsOptOrderUA:SetScript("OnValueChanged", function()
		AffDotsOpt.ua_order = Round(AffDotsOptOrderUA:GetValue())-1
		getglobal(AffDotsOptOrderUA:GetName() .. 'Text'):SetText(Round(AffDotsOptOrderUA:GetValue()))
		InitFrames();
	end)

	AffDotsOptColorSwitch:SetScript("OnValueChanged", function()
		AffDotsOpt.color_switch = 1 + Round(AffDotsOptColorSwitch:GetValue())/100
		getglobal(AffDotsOptColorSwitch:GetName() .. 'Text'):SetText((AffDotsOpt.color_switch-1)*100);
	end)

	AffDotsOptReset:SetScript("OnClick", function()
		AffDotsOpt.x = nil
		AffDotsOpt.y = nil
		AffDotsOpt.p = nil
		AffDotsOpt.rp = nil
		AffDotsOpt.focus_x = nil
		AffDotsOpt.focus_y = nil
		AffDotsOpt.focus_p = nil
		AffDotsOpt.focus_rp = nil
		InitFrames()
	end)
	
	AffDotsOptClose:SetScript("OnClick", function()
		AffDotsOptions:Hide()
		Visibility()
	end)
end

local function CleanTargets(force)
	local t = GetTime()
	for k,v in pairs(targets) do
		if force then
			if targets[k][2] < t-100 then targets[k]=nil end
		else
			targets[k]=nil
		end
	end
end

local function onUpdate(self,elapsed)
    timer = timer + elapsed;
    if timer >= 0.2 then
		for k,v in pairs(active_frames) do
			SetText(active_frames[k])
		end
        timer = 0
    end
end

local function Events()
	if(select(2, UnitClass("player")) == "WARLOCK") then
		m:RegisterEvent("COMBAT_LOG_EVENT")
		CombatLogAddFilter("SPELL_DAMAGE,SPELL_AURA_APPLIED,SPELL_AURA_REFRESH", me)
		m:RegisterEvent("PLAYER_REGEN_ENABLED")
		m:RegisterEvent("PLAYER_REGEN_DISABLED")
		m:RegisterEvent("COMBAT_RATING_UPDATE")
		m:RegisterEvent("SPELL_POWER_CHANGED")
		m:RegisterEvent("PLAYER_DAMAGE_DONE_MODS")
		m:RegisterEvent("PLAYER_FOCUS_CHANGED")
		m:SetScript("OnUpdate", onUpdate)
	else
		m:SetScript("OnUpdate", nil)
		m:UnregisterEvent("SPELL_POWER_CHANGED")
		m:UnregisterEvent("COMBAT_RATING_UPDATE")
		m:UnregisterEvent("PLAYER_DAMAGE_DONE_MODS")
		m:UnregisterEvent("PLAYER_REGEN_DISABLED")
		m:UnregisterEvent("PLAYER_REGEN_ENABLED")
		m:UnregisterEvent("PLAYER_FOCUS_CHANGED")
		m:UnregisterEvent("COMBAT_LOG_EVENT")
		m:Hide()
		return
	end
end

SLASH_AFFDOTS1 = '/affdots'
function AffDotsHandler(msg, editBox)
	Unlock(true)
	m:Show();f:Show();
	AffDotsOptions:Show()
	Visibility()
end
SlashCmdList["AFFDOTS"] = AffDotsHandler

local function VariablesLoaded()
	if(not AffDotsOpt) 				then AffDotsOpt = {} end
	if(not AffDotsOpt.layout) 		then AffDotsOpt.layout 		= "vertical" 	end
	if(not AffDotsOpt.text) 		then AffDotsOpt.text 		= "absolute" 	end
	if(not AffDotsOpt.scale) 		then AffDotsOpt.scale 		= 1 			end
	if(not AffDotsOpt.focus_scale) 	then AffDotsOpt.focus_scale = 0.8 			end
	if(not AffDotsOpt.agony_order) 	then AffDotsOpt.agony_order = 0 			end
	if(not AffDotsOpt.corr_order) 	then AffDotsOpt.corr_order 	= 1 			end
	if(not AffDotsOpt.ua_order) 	then AffDotsOpt.ua_order 	= 2 			end
	if(not AffDotsOpt.haunt_order) 	then AffDotsOpt.haunt_order = 3 			end
	if(not AffDotsOpt.demo_corr)	then AffDotsOpt.demo_corr 	= 0 			end
	if(not AffDotsOpt.demo_doom)	then AffDotsOpt.demo_doom 	= 1 			end
	if(not AffDotsOpt.destro_immo)	then AffDotsOpt.destro_immo	= 0 			end
	if(not AffDotsOpt.hide) 		then AffDotsOpt.hide 		= false 		end
	if(not AffDotsOpt.focus) 		then AffDotsOpt.focus 		= true	 		end
	if(not AffDotsOpt.coe)	 		then AffDotsOpt.coe 		= true	 		end
	if(not AffDotsOpt.color_switch) then AffDotsOpt.color_switch= 1.2 			end
	if(not AffDotsOpt.icon_pos)		then AffDotsOpt.icon_pos 	= 0 			end
	if(not AffDotsOpt.transparency) then AffDotsOpt.transparency= 0.5 			end
	if(not AffDotsOpt.color1) 		then AffDotsOpt.color1 = {0,0.5,0} 			end
	if(not AffDotsOpt.color2) 		then AffDotsOpt.color2 = {0,0,0.5} 			end
	if(not AffDotsOpt.color3) 		then AffDotsOpt.color3 = {0.5,0.5,0}		end
	if(not AffDotsOpt.color4) 		then AffDotsOpt.color4 = {0.5,0,0} 			end
	if(not AffDotsOpt.color5) 		then AffDotsOpt.color5 = {0,0,0} 			end
	colors = {AffDotsOpt.color1,AffDotsOpt.color2,AffDotsOpt.color3,AffDotsOpt.color4,AffDotsOpt.color5}
	OptionsFrameFunctions()
	Unlock(false)
	Visibility()
end

function AffDotsOnEvent(frame, event, ...)
	if event == "COMBAT_LOG_EVENT" then
		_,event_type,_,source_GUID,_,_,_,dest_GUID,_,_,_,spell = select(1, ...)
		if(dest_GUID ~= me) then CombatLog(event_type,spell,dest_GUID) end
	elseif(event == "PLAYER_DAMAGE_DONE_MODS" or event == "COMBAT_RATING_UPDATE" or event == "SPELL_POWER_CHANGED") then
		GetDotDmg()
	elseif event == "PLAYER_REGEN_ENABLED" then
		in_combat = false; Visibility()
		CleanTargets(false)
	elseif event == "PLAYER_REGEN_DISABLED" then
		in_combat = true; Visibility()
	elseif event == "PLAYER_FOCUS_CHANGED" then
		Visibility()
	elseif event == "VARIABLES_LOADED" then
		VariablesLoaded()
	elseif event == "ACTIVE_TALENT_GROUP_CHANGED" then
		spec 	= GetSpecialization()
		GetDotDmg()
		CleanTargets(true)
		Events()
		InitFrames()
	elseif (event == "PLAYER_ALIVE" or event == "PLAYER_ENTERING_WORLD") then
		me = UnitGUID("player")
		class 	= select(2, UnitClass("player"))
		spec 	= GetSpecialization()
		Events()
		InitFrames()
	end
end